# VS Code Debugging

**Objectives**

In this lesson, we are going to quickly review how to debug with Visual Studio Code. This lesson assumes that you have a basic  understanding of debugging terms. While the code in some pictures is in python, the same process applies to C.

**Learning objects include:**
* **Accessing Debug View and Menu**
* **Launch Configurations**
* **Breakpoints**
* **Debug Actions**
* **Advanced Breakpoint Topics**

---

**Accessing Debug View and Menu**

To get to the Debug view click on the Debug icon in the Activity bar on the left side of your VS Code Window. Alternatively you can use the shortcut ***Ctrl+Shift+D***

![](../assets/vscodedebugicon.PNG)

You can also go to the Debug menu located at the top of the VS Code window to access the most common debug commands. 

![](../assets/vscodedebugmenu.PNG)

---

**Launch Configurations**

You may notice that there are no configurations next to the play button in the debug window. The gear icon also has an orange circle indicator letting you know that it needs a launch.json file.

![](../assets/vscodenoconfigurations.PNG)

The first time you try to debug a file, VS Code will create a .vscode folder and within it there will be a launch.json file added to your workspace. Don't worry about this too much at the moment, just know that you have to add a configuration for Python, or for any other language you decide to debug with. When you start using the debugger more often you can get into messing with intellisense to see all of the other possible attributes of the launcher.

The launch.json file should look similar to the following. 

![](../assets/vscodelaunch.PNG)

If this is the case then when you hit the debug button then you shouldn't have any issues using the debugger. 

---

**Breakpoints**

To set a breakpoint click on the blank space to the left of the row number. This area is known as the editor margin. When you left click you will see a red circle appear. To remove you simply left click on the red circle and it will go away. Alternatively you can right click and remove the breakpoint. 

![](../assets/vscoderemovebreakpoint.PNG)

You can also toggle this breakpoint by selecting the line and pressing the F9 shortcut.

Execution of code is stopped at your assigned breakpoints. You can hover over variables at this point to see their current values. You can also see the values to those variables to the left in the debug window. 

![](../assets/vscodebreakpoint.PNG)

---

**Debug Actions**

Once you have successfully started debugging you will notice a Debug Toolbar that appears. This toolbar has the following options:

* **Continue/Pause (F5)**
* **Step Over (F10)**
* **Step Into (F11)**
* **Step Out (Shift + F11)**
* **Restart (Ctrl + Shift + F5)**
* **Stop (Shift + F5)**

The icons shown below are in the same order as listed above.

![](../assets/vscodestepthroughicons.PNG)

---

**Advanced Breakpoint Topics**

There are a lot of interesting different ways you can interact with breakpoints in VS Code. These include expressions, hit counts, and log messages. If you right click on the breakpoint and select "Edit Breakpoint..." you will see that you can use the dropdown to select one of three options. 

![](../assets/vscodeeditbreakpoint.PNG)

![](../assets/vscodeeditbreakoptions.PNG)

* **Expression Condition** - With this you can decide to stop at a breakpoint if a specific condition is met. For example if x = y, or if name = 'NameYouAreExpecting'.

* **Hit Count** - This controls how many times a breakpoint needs to be hit before it will break the execution.

* **Log Message** - This is a great tool to replace random print debug statements. The advantage to this is that you don't need to keep track of your print debug statements and can avoid accidentally deleting code you actually need. You can see the output in the debug console. 

---

**Raised Exceptions**

You can also check the "Raised Exceptions" checkbox in the breakpoints window if you want your program to stop when an exception is raised.

![](../assets/vscoderaisedexceptions.PNG)

---

## **Summary**

In this lesson we covered how to debug in VS Code. This introduction covered topics such as how to access the debug window, launch configurations, breakpoints, debug actions, and advanced breakpoint topics.

There are lots of other exciting things you can utilize in VS Code to make debugging your code more stream lined. Feel free to explore and check them out. 
